<script lang="ts">
  import { GetEventsStore } from '$houdini';
  import Dropdown from '$lib/components/ui-elements/Dropdown.svelte';
  import type { Event } from '$lib/graphql/types';
  import { createEventDispatcher } from 'svelte';

  export let multiple = false;
  export { clazz as class };

  let clazz = '';
  let events: Partial<Event>[];
  const dispatch = createEventDispatcher();

  async function fetchEvents() {
    const ret = (await new GetEventsStore().fetch()).data;
    if (ret !== null && ret.events !== null) {
      events = ret.events;
    }
    return ret;
  }

  function handleSelection(evt: CustomEvent) {
    dispatch('select', events.find((e) => evt.detail?.startsWith(e.name))?.id || null);
  }
</script>

{#await fetchEvents()}
  <!-- Display fake button while real dropdown button data loads-->
  <div class="relative inline-block text-left {clazz || ''}">
    <button
      type="button"
      class="inline-flex w-full justify-center rounded-md border border-gray-300 bg-white px-4 py-2 text-sm font-medium text-gray-700 shadow-sm hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 focus:ring-offset-gray-100">
      Loading...
    </button>
  </div>
{:then v}
  {#if v != null}
    <Dropdown
      class={clazz}
      on:select={handleSelection}
      title="Select an Event"
      {multiple}
      options={events.map((evt) => `${evt.name} (${evt.start?.toLocaleDateString()})`)} />
  {:else}
    <div class="relative inline-block text-left {clazz || ''}">
      <button
        type="button"
        class="inline-flex w-full justify-center rounded-md border border-gray-300 bg-white px-4 py-2 text-sm font-medium text-gray-700 shadow-sm hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 focus:ring-offset-gray-100">
        Load Failed
      </button>
    </div>
  {/if}
{/await}
